# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2009 Smile.fr. All Rights Reserved
#    authors: Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv


class account_move_line(osv.osv):
    _inherit = "account.move.line"
    
    def _get_sale_order_id(self, cr, uid, ids, name, arg, context=None):
        res = {}
        for move_line in self.browse(cr, uid, ids, context):
            if move_line.invoice and move_line.invoice.origin_sale_order_id:
                res[move_line.id] = move_line.invoice.origin_sale_order_id.id
            else:
                res[move_line.id] = False
        return res
    
    def _get_sale_shop_id(self, cr, uid, ids, name, arg, context=None):
        res = {}
        for move_line in self.browse(cr, uid, ids, context):
            if move_line.invoice and move_line.invoice.origin_sale_shop_id:
                res[move_line.id] = move_line.invoice.origin_sale_shop_id.id
            else:
                res[move_line.id] = False
        return res
    
    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context={}, toolbar=False):
        result = super(account_move_line, self).fields_view_get(cr, uid, view_id,view_type,context,toolbar=toolbar)
        xml = result['arch']
        xml = xml.replace('</tree>', "<field name=\"origin_sale_order_id\" select='2'/><field name=\"origin_sale_shop_id\" select='2'/></tree>")
        result['arch'] = xml
        fields = []
        result['fields']['origin_sale_order_id'] = {'type': 'many2one', 'domain': [], 'relation': 'sale.order', 'string': u'Origin Sale Order', 'context': ''}
        result['fields']['origin_sale_shop_id'] = {'type': 'many2one', 'domain': [], 'relation': 'sale.shop', 'string': u'Origin Sale Shop', 'context': ''}
        print "----------------------------"
        for i in result:
            print i

        print "type", result.get('type', False)
        print "toolbar", result.get('toolbar', False)
        print "fields", result['fields']
        return result

    _columns = {
            'origin_sale_order_id': fields.function(_get_sale_order_id, method=True, store=False, relation="sale.order", string="Origin Sale Order", type="many2one", select='2'),
            'origin_sale_shop_id': fields.function(_get_sale_shop_id, method=True, store=False, relation="sale.shop", string="Origin Sale Shop", type="many2one", select='2'),                
    }

account_move_line()