# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2009 Smile.fr. All Rights Reserved
#    authors: Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv


class account_invoice(osv.osv):
    _inherit = "account.invoice"
    
    def _get_sale_order_id(self, cr, uid, ids, name, arg, context=None):
        res = {}
        for invoice in self.browse(cr, uid, ids, context):
            if invoice.sale_ids:
                res[invoice.id] = invoice.sale_ids[0].id
            else:
                res[invoice.id] = False
        return res
    
    def _get_sale_shop_id(self, cr, uid, ids, name, arg, context=None):
        res = {}
        for invoice in self.browse(cr, uid, ids, context):
            if invoice.sale_ids:
                res[invoice.id] = invoice.sale_ids[0].shop_id and invoice.sale_ids[0].shop_id.id or False
            else:
                res[invoice.id] = False
        return res

    #implemented because for strange reasons search on fields.function of type many2one doesn't work natively!
    def search(self, cr, uid, args, offset=0, limit=None, order=None,
            context=None, count=False):
        origin_sale_order_name = False
        origin_sale_shop_name = False
        args2 = args[:]
        for arg in args:
            if arg[0] == 'origin_sale_order_id':
                origin_sale_order_name = arg[2]
                args2.remove(arg)
            if arg[0] == 'origin_sale_shop_id':
                origin_sale_shop_name = arg[2]
                args2.remove(arg)
        ids = super(account_invoice, self).search(cr, uid, args2, offset, limit, order, context, count)
        
        if len(ids) > 1 and origin_sale_order_name:
            cr.execute(("select account_invoice.id from account_invoice left join sale_order on account_invoice.origin_sale_order_id=sale_order.id where sale_order.name ilike '%s' and account_invoice.id in %s" % ('%' + origin_sale_order_name + '%', ids)).replace('[', '(').replace(']', ')'))
            results = cr.fetchall()
            ids = [line[0] for line in results]
            
        if len(ids) > 1 and origin_sale_shop_name:
            cr.execute(("select account_invoice.id from account_invoice left join sale_shop on account_invoice.origin_sale_shop_id=sale_shop.id where sale_shop.name ilike '%s' and account_invoice.id in %s" % ('%' + origin_sale_shop_name + '%', ids)).replace('[', '(').replace(']', ')'))
            results = cr.fetchall()
            ids = [line[0] for line in results]
        return ids

    _columns = {
            'origin_sale_order_id': fields.function(_get_sale_order_id, method=True, store=True, relation="sale.order", string="Origin Sale Order", type="many2one", select='2'),
            'origin_sale_shop_id': fields.function(_get_sale_shop_id, method=True, store=True, relation="sale.shop", string="Origin Sale Shop", type="many2one", select='2'),
    }

account_invoice()