#!/usr/bin/env python
#coding: utf-8
#
# (c) 2007-2008 Sednacom <http://www.sednacom.fr>
#
# authors :
#  - Brice < brice@sednacom.fr >
#  - Gael < gael@sednacom.fr >
import wizard
import pooler

from alerts.alerts import _models_get, _default_date

init_form_desc = """<?xml version="1.0"?>
<form string="Alert">
    <field name="name" colspan="4" />
    <separator string="Message" colspan="4" />
    <field colspan="4" name="message" nolabel="1"/>
    <field name="datetime" />
    <field name="user_to" />
    <field name="by_mail"/>
    <field name="by_request"/>
    <field name="resource" colspan="4" />
</form>
"""

init_form_fields = {
    'name' : {
        'string' : 'Description' ,
        'type' : 'char' ,
        'size' : 64 ,
        'required' : True ,
    },
    'datetime' : {
        'string' : 'Date/Time' ,
        'type' : 'datetime' ,
        'required' : True ,
    },
    'user_to' : {
        'string' : 'User to' ,
        'type' : 'many2one' ,
        'relation' : 'res.users' ,
        'required' : True ,
    },
    'by_mail' : {
        'string' : 'Alert by mail' ,
        'type' : 'boolean'
    },
    'by_request' : {
        'string' : 'Alert by request' ,
        'type' : 'boolean'
    },
    'resource' : {
        'string' : 'Resource' ,
        'type' : 'reference' ,
        'selection' : _models_get ,
    },
    'message' : {
        'string' : 'Message' ,
        'type' : 'text' ,
    },

}

def _init_form(obj, cr, uid, data, context={}):
    #print 'data::_init_form',data
    res = {
        'user_to' : uid ,
        'datetime' : _default_date() ,
        'by_mail' : True ,
        'by_request' : False ,
        'resource' : '%s,%s' % (data['model'],data['id']) ,
    }

    return res

def _add_alert(obj, cr, uid, data, context={}):
    #print 'data::_add_alert',data
    pooloo = pooler.get_pool(cr.dbname)
    vals = data['form']
    vals['user_from'] = uid
    o_alert = pooloo.get('sednacom.alert')
    alert = o_alert.create(cr, uid, vals)
    ids = []
    ids.append(int(alert))
    o_alert.send_alert(cr, uid, ids)
    return True

class wizard_set_alert( wizard.interface ):
    states = {
        'init' : {
            'actions' : [ _init_form , ],
            'result' : {
                'type' : 'form' ,
                'arch': init_form_desc ,
                'fields': init_form_fields ,
                'state': [( 'end', 'Cancel' ), ( 'add', 'Add alert' ), ],
                }
            },
        'add' : {
            'actions' : [],
            'result' : {
                'type' : 'action' ,
                'state' : 'end' ,
                'action' : _add_alert,
                }
            },
    }

wizard_set_alert( 'sednacom.setalert' )
