# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2009 Gábor Dukai
#    Parts of this module are based on product_listprice_upgrade
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import osv, fields

class res_partner_category(osv.osv):
    _inherit = 'res.partner.category'

    _columns = {
        'restricted': fields.boolean('Restricted'),
    }

    _defaults = {
        'restricted': lambda *a: False,
    }

res_partner_category()

class res_partner(osv.osv):
    _inherit = 'res.partner'

    def _is_restricted(self, cr, uid, ids, name, args, context=None):
        res = {}
        for partner in self.browse(cr, uid, ids, context=context):
            res[partner.id] = False
            has_restricted = False
            has_allowed = False
            for cat in partner.category_id:
                if cat.restricted:
                    has_restricted = True
                else:
                    has_allowed = True
            if has_restricted and not has_allowed:
                res[partner.id] = True
        return res

    def _get_categories(self, cr, uid, ids, context):
        return self.pool.get('res.partner').search(cr, uid, [('category_id', 'in', ids)])

    _columns = {
        'restricted': fields.function(_is_restricted, method=True, type='boolean', string='Restricted', store={
                'res.partner': (lambda self,cr,uid,ids,c={}: ids, ['category_id'], 10),
                'res.partner.category': (_get_categories, ['restricted'], 10),
            }),
    }

res_partner()

#class res_partner_address(osv.osv):
#    _inherit = 'res.partner.address'
#
#    def _is_restricted(self, cr, uid, ids, name, args, context=None):
#        res = {}
#        for addr in self.browse(cr, uid, ids, context=context):
#            if addr.partner_id.restricted:
#                res[addr.id] = True
#            else:
#                res[addr.id] = False
#        return res
#
#    def _get_partner(self, cr, uid, ids, context):
#        return self.pool.get('res.partner.address').search(cr, uid, [('partner_id', 'in', ids)])
#
#    def _get_categories(self, cr, uid, ids, context):
#        partner_ids = self.pool.get('res.partner').search(cr, uid, [('category_id', 'in', ids)])
#        return self.pool.get('res.partner.address').search(cr, uid, [('partner_id', 'in', partner_ids)])
#
#    _columns = {
#        'restricted': fields.function(_is_restricted, method=True, type='boolean', string='Restricted', store={
#                'res.partner': (_get_partner, ['category_id'], 20),
#                'res.partner.category': (_get_categories, ['restricted'], 20),
#            }),
#    }
#
#res_partner_address()