#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from osv import osv, fields
import tools
from mx import DateTime
import netsvc

def _default_purchase_analytic( obj, cr, uid, context):
    #print '_default_purchase_analytic',context
    business_id = context.get( 'business_id', False )
    if business_id:
        res = obj.pool.get( 'business.business' ).browse( cr, uid, business_id, context ).analytic_account.id
    else:
        res = False
    #purchase_order_obj = obj.pool.get('purchase.order').browse( cr, uid, context )
    
    #print purchase_order_obj
    return res

class business_business(osv.osv):
  _name = "business.business"
  _description = "business affair"

  def make_list_partners(self, cr, uid, ids,business, arg, context):	
	for busi in self.browse(cr, uid, ids):
		business_id = busi.name
	res1=[]	
	if business_id:
		crit = [('business_id','=',business_id)]		
		res2 = self.pool.get('sale.order').search(cr, uid, crit)	
		for sale in self.pool.get('sale.order').browse(cr, uid, res2):
			res1.append(sale.partner_id.id)		
		res3 = self.pool.get('purchase.order').search(cr, uid, crit)		
		for purchase in self.pool.get('purchase.order').browse(cr, uid, res3):
			res1.append(purchase.partner_id.id)			
		res = unique(res1)
		print res		
	else:
		return False
	return res

  _columns = {
	'name' : fields.char('Business', size=64, required=True),
	'code' : fields.char('Business Number', size=64, required=True),
	'date_start': fields.date('Start Date'),
	'date_end': fields.date('End Date'),
	'analytic_account' : fields.many2one('account.analytic.account', 'Analytic Account',required=False),
	#'list_partners' : fields.one2many('partner.from.list', 'business_id', 'Sale', readonly=True),
	'sales' : fields.one2many('sale.order', 'business_id', 'Sales'),
	'purchases' : fields.one2many('purchase.order', 'business_id', 'Purchases'),
	'invoices' :fields.one2many('account.invoice', 'business_id', 'Invoices'),
	'projects' : fields.one2many('project.project', 'business_id', 'Projects'),
	}

business_business()

class sale_order(osv.osv):
  _name = "sale.order"
  _inherit = "sale.order"
  _description = "Sale order with business affair"

  _columns = {
	'business_id' : fields.many2one('business.business','Business', required=False , readonly=True, states={'draft':[('readonly',False)]}),
	}

  def onchange_business_id(self, cr, uid, ids, business_id):
	if not business_id:
		return {}
	analytic = self.pool.get('business.business').browse(cr, uid, business_id).analytic_account.id	
	return {'value':{'project_id': analytic}}

  def action_invoice_create(self, cr, uid, ids, grouped=False, states=['confirmed','done']):
		res = super(sale_order, self).action_invoice_create(cr, uid, ids, grouped, states)			
		for o in self.browse(cr, uid, ids):		
			inv = self.pool.get('account.invoice').write(cr, uid, [res], {'business_id': o.business_id.id})		
		return res
sale_order()

class purchase_order(osv.osv):
  _name = "purchase.order"
  _inherit = "purchase.order"
  _description = "Purchase order with business affair"

  _columns = {
	'business_id' : fields.many2one('business.business','Business', required=False, readonly=True, states={'draft':[('readonly',False)]}),
	}


  def action_invoice_create(self, cr, uid, ids, *args):
		res = super(purchase_order, self).action_invoice_create(cr, uid, ids, *args)		
		for o in self.browse(cr, uid, ids):		
			inv = self.pool.get('account.invoice').write(cr, uid, [res], {'business_id': o.business_id.id})		
		return res
purchase_order()

class purchase_order_line(osv.osv):
  _name = "purchase.order.line"
  _inherit = "purchase.order.line"
  _description = "purchase order line with business affair"

  _defaults = {
	'account_analytic_id' : lambda *args : _default_purchase_analytic( *args ) , 
       }
purchase_order_line()

class account_invoice(osv.osv):
  _name = "account.invoice"
  _inherit = "account.invoice"
  _description = "invoice with business affair"

  _columns = {
	'business_id' : fields.many2one('business.business','Business', required=False, readonly=True, states={'draft':[('readonly',False)]}),
	}

account_invoice()



class project(osv.osv):
  _name = "project.project"
  _inherit="project.project"
  _description = "Project with business affair"

  _columns = {
	'business_id' : fields.many2one('business.business','Business', required=False),
	'category_id': fields.many2one('account.analytic.account','Analytic Account'),	
	}

  def onchange_business_id(self, cr, uid, ids, business_id):
	if not business_id:
		return {}
	analytic = self.pool.get('business.business').browse(cr, uid, business_id).analytic_account.id	
	return {'value':{'category_id': analytic}}

project()

class partner_from_sale(osv.osv):
	_name = "partner.from.sale"
	_description = "Partners from business sales"
	_order='partner_id'
	_auto = False
	_columns = {
		'name': fields.one2many('sale.order', 'business_id', 'Sale Order', readonly=True),
		'business_id': fields.many2one('business.business','Business'),
		'partner_id' : fields.many2one('res.partner','Partner'),
	}
	def init(self, cr):
		cr.execute("""
			create or replace view partner_from_sale as (
				select
					id, partner_id,business_id,name 
						from 
							sale_order 
						)""")
partner_from_sale()

class partner_from_purchase(osv.osv):
	_name = "partner.from.purchase"
	_description = "Partners from business purchases"
	_order='partner_id'
	_auto = False
	_columns = {
		'name': fields.one2many('purchase.order', 'business_id', 'Purchase Order', readonly=True),
		'business_id': fields.many2one('business.business','Business'),
		'partner_id' : fields.many2one('res.partner','Partner'),
	}
	def init(self, cr):
		cr.execute("""
			create or replace view partner_from_purchase as (
				select
					id, partner_id,business_id,name 
						from 
							purchase_order 
						)""")
partner_from_purchase()

class partner_from_invoice(osv.osv):
	_name = "partner.from.invoice"
	_description = "Partners from business invoices"
	_order='partner_id'
	_auto = False
	_columns = {
		'name': fields.one2many('account_invoice', 'business_id', 'Purchase Order', readonly=True),
		'business_id': fields.many2one('business.business','Business'),
		'partner_id' : fields.many2one('res.partner','Partner'),
	}
	def init(self, cr):
		cr.execute("""
			create or replace view partner_from_invoice as (
				select
					id, partner_id,business_id,name 
						from 
							account_invoice 
						)""")
partner_from_invoice()

class partner_from_list(osv.osv):
	_name = "partner.from.list"
	_description = "Partners from business"
	_order='partner_id'
	_auto = False
	_columns = {
		'business_id': fields.many2one('business.business','Business'),		
		'partner_id' : fields.many2one('res.partner','Partner'),
	}
	def init(self, cr):
		cr.execute("""
			create or replace view partner_from_list as (
				SELECT DISTINCT r.id,r.id as partner_id,b.id as business_id
					FROM res_partner r, business_business b, 
						partner_from_invoice i, partner_from_sale s,
						partner_from_purchase p
					WHERE b.id=p.business_id and b.id=s.business_id and b.id=i.business_id
						)""")
partner_from_list()

