#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import time
from report import report_sxw
from osv import osv

class catalog(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(catalog, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'lines': self.lines,
        })
        self._context=context

    def preprocess(self, objects, data, ids):
        category = data['form']['category_id']
        crit = [('parent_id','child_of',category),]
        new_ids = self.pool.get('product.category').search(self.cr, self.uid, crit)
        prod_ids=[]
        zero_id=[]
        for id_cat in new_ids:
            crit2 = [('categ_id','=',id_cat)]
            cat_zero = self.pool.get('product.product').search(self.cr, self.uid, crit2)
            crit_noactif = [('categ_id','=',id_cat),('active','=', 0),]
            cat_noact = self.pool.get('product.product').search(self.cr, self.uid, crit_noactif)
            if cat_zero and cat_noact:
                zero_id.append(id_cat)
                prod_ids+=cat_zero
                prod_ids+=cat_noact
            if cat_noact and not cat_zero:
                if data['form']['state_product']=="inctive" or data['form']['state_product']=="all":
                    prod_ids+=cat_noact
                zero_id.append(id_cat)
            if not cat_noact and cat_zero:
                if data['form']['state_product']=="active" or data['form']['state_product']=="all":
                    zero_id.append(id_cat)
                prod_ids+=cat_zero
        self._prod_ids=prod_ids
        if data['form']['cat_zero']:
            new_ids=zero_id
        self._report_product = self.pool.get('product.product').browse(self.cr, self.uid, prod_ids, context=self._context)
        self._data = data
        self._report_data = self._build_data ( new_ids )
        new_objects = self.pool.get('product.category').browse(self.cr, self.uid, new_ids, context=self._context)
        super(catalog, self).preprocess(new_objects, data, new_ids)

    def _build_data(self, new_ids):
        ret = {}
        for categ in new_ids:
            state = self._data['form']['state_product']
            o_prd = self.pool.get('product.product')
            lst = ret.get( categ , list() )
            if not lst:
                ret[categ]=lst
            if state == 'active':
                crit3 = ('active','=', 1)
            elif state== 'inactive':
                crit3 = ('active','=', 0)
            else :
                crit3 = ('active','=', 1)
                crit4= [('categ_id','=',categ),('active','=', 0),]
                line_ids = o_prd.search(self.cr, self.uid, crit4)
                for prd in line_ids:
                    prd_id = self._prod_ids.index(prd)
                    if not self._report_product[prd_id].qty_available:
                        self._report_product[prd_id].qty_available = '0.0'
                    if self._report_product[prd_id].active==1:
                        self._report_product[prd_id].active="True"
                    elif self._report_product[prd_id].active==0:
                        self._report_product[prd_id].active="False"

                    lst.append(
                        {'code' : self._report_product[prd_id].code,
                        'name' : self._report_product[prd_id].name,
                        'price_std' : self._report_product[prd_id].standard_price,
                        'list_price' : self._report_product[prd_id].list_price,
                        'catalog' : self._report_product[prd_id].categ_id.name,
                        'qty_available' : self._report_product[prd_id].qty_available,
                        'active' : self._report_product[prd_id].active,
                        })
            crit2= [('categ_id','=',categ),crit3]
            line_ids = o_prd.search(self.cr, self.uid, crit2)
            for prd in line_ids:
                prd_id = self._prod_ids.index(prd)
                if not self._report_product[prd_id].qty_available:
                    self._report_product[prd_id].qty_available = '0.0'
                if self._report_product[prd_id].active==1:
                    self._report_product[prd_id].active="True"
                elif self._report_product[prd_id].active==0:
                    self._report_product[prd_id].active="False"
                lst.append(
                    {'code' : self._report_product[prd_id].code,
                    'name' : self._report_product[prd_id].name,
                    'price_std' : self._report_product[prd_id].standard_price,
                    'list_price' : self._report_product[prd_id].list_price,
                    'catalog' : self._report_product[prd_id].categ_id.name,
                    'qty_available' : self._report_product[prd_id].qty_available,
                    'active' : self._report_product[prd_id].active,
                    })

        return ret

    def lines(self, categ):
        ret = self._report_data[categ.id]
        return ret


report_sxw.report_sxw('report.catalog', 'catalog', 'addons/catalog/report/catalog.rml', parser=catalog,header=False)

