# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 HASA SARL. (http://www.hasa.ch) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv

class account_move_line(osv.osv):
    """Add of a method in account move line"""
    _name = 'account.move.line'
    _inherit = 'account.move.line'

    def _check_line_period(self, cr, uid, ids):
        """check if the move line date is included in the move line period"""
        lines = self.browse(cr, uid, ids)
        for l in lines:
            if l.date < l.period_id.date_start or \
            l.date > l.period_id.date_stop:
                return False
        return True

    _constraints = [
        (_check_line_period, 'You can not create move line with a date not \
        included in the move line period.', ['date','period_id']),
    ]
    
account_move_line()

class account_move(osv.osv):
    """Add of a method in account move"""
    _name = 'account.move'
    _inherit = 'account.move'

    def _check_move_period(self, cr, uid, ids):
        """check if the account move date is included in the move period"""
        moves = self.browse(cr, uid, ids)
        for m in moves:
            if m.date < m.period_id.date_start or \
            m.date > m.period_id.date_stop:
                return False
        return True

    _constraints = [
        (_check_move_period, 'You can not create move with a date not \
        included in the move period.', ['date','period_id']),
    ]
    
account_move()
