# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 HASA SARL. (http://www.hasa.ch) All Rights Reserved.
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard

class wizard_account_move_line(wizard.interface):
    """wizard that display the incorrect account move lines"""

    def _trouble_entries_lines_open_window(self, cr, uid, data, context):
        """check all the account move line date in period"""
        cr.execute('select id,name from ir_ui_view where model=%s and \
        type=%s', ('account.move.line', 'tree'))
        view_res = cr.fetchone()
        cr.execute('select id from account_move_line as line where date < \
        (select date_start from account_period where id = line.period_id) \
        or date > (select date_stop from account_period \
        where id = line.period_id)')
        lines = cr.fetchall()
        domain = "[('id', 'in', ["+','.join(map(str, lines))+"])]"

        return {
            'domain': domain,
            'name': 'Trouble Entries Lines',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.move.line',
            'view_id': view_res,
            'type': 'ir.actions.act_window'
        }        

    states = {
        'init': {
            'actions': [],
            'result': {'type': 'action', \
            'action':_trouble_entries_lines_open_window, 'state':'end'}
        }
    }
wizard_account_move_line('account.trouble_entries_lines')

class wizard_account_move(wizard.interface):
    """wizard that display the incorrect account moves"""

    def _trouble_moves_open_window(self, cr, uid, data, context):
        """check all the account move date if in period"""
        cr.execute('select id,name from ir_ui_view where model=%s and \
        type=%s', ('account.move', 'tree'))
        view_res = cr.fetchone()
        cr.execute('select id from account_move as move where date < \
        (select date_start from account_period where id = move.period_id) \
        or date > (select date_stop from account_period \
        where id = move.period_id)')
        lines = cr.fetchall()
        domain = "[('id', 'in', ["+','.join(map(str, lines))+"])]"

        return {
            'domain': domain,
            'name': 'Trouble Move Lines',
            'view_type': 'form',
            'view_mode': 'tree,form',
            'res_model': 'account.move',
            'view_id': view_res,
            'type': 'ir.actions.act_window'
        }        

    states = {
        'init': {
            'actions': [],
            'result': {'type': 'action', \
            'action':_trouble_moves_open_window, 'state':'end'}
        }
    }
wizard_account_move('account.trouble_moves')
