# -*- encoding: utf-8 -*-
{    
    "name": "Multi-company product cost price",
    "version": "0.2",
    "author": "Hasa Sàrl",
    "category": "Generic Modules/Others",
    "website": "http://www.hasa.ch",
    "description": """
This module modifies the product cost price for a multi-company use. No more need to have the same product for each company you manage to have the right cost price.

It adds in the database the table product_multicostprice which makes the relation between a product, a company and a cost price. It allows to have different cost prices for the same product depending on the user company. 

When you received products and you validate the incoming packing list, the rewrite "Make packing" wizard will check the quantity of each product in all the stock location of the user company, calculate the new cost price and update it in the table product_multicostprice.
    
!!!!!!TRY THIS MODULE ON A TEST DATABASE FIRST!!!!!!

CHANGES :
- Addition of the company field on stock locations
- The cost price (standard price) field in the product is now read only. It is a function that get the right cost price (depending the user company) in the table product_multicostprice.
- The cost prices are automatically calculated when the products are received (use of the "make packing" wizard when an incoming packing list is validated).
- To manually modify a product cost price you must load the view "Products/Products cost price" which is a list of all the products per companies. You have to be in the group "Product / Manager", otherwise you can only read the cost prices.

HOWTO :
1. !!!MAKE A BACKUP OF THE DATABASE!!!
2. You need to define which stock location will be used for the cost price calculation. You have to fill the company field ONLY on the stock location that will be used to calculate the amount of product in stock. I.e. don't fill the company on an output stock. Menu : "Stock management/Configuration/Locations"
3. You can manually change the product cost price in "Products/Products cost price" or import them (make a csv file with the columns : product name or code, partner name, cost price).
4. Don't forget to choose "Average Price" as the costing method on the concerned products. It allows to recompute the cost price at each reception of products.

-------------------

Ce module permet une utilisation multi-sociétés du prix standard (prix d'achat) des produits. Plus besoin d'avoir un produit par société gérée pour calculer son prix d'achats.

Ce module ajoute dans la base de donnée la table product_multicostprice qui permet de mettre en relation une société, un produit et son prix d'achat.

Quand vous réceptionnez des produits et validez la liste de colisage entrante, le wizard "Make Packing" va vérifier les disponibilités de chaque produit dans les stocks de la société de l'utilisateur, calculer son nouveau prix d'achat et le mettre à jour dans la table product_multicostprice.

!!!!!!ESSAYEZ CE MODULE SUR UNE BASE DEMO AVANT DE L'UTILISER EN PRODUCTION!!!!!!

Modifications :
- Ajout du champ "Company (cost price)" dans le formulaire des emplacements de stock.
- Le champ prix standard (prix d'achat) des produits est maintenant en lecture seule. Une fonction va automatiquement rechercher le bon prix pour la société de l'utilisateur.
- Les prix d'achats sont automatiquement calculés lors de la réception des produits (utilisation du wizard "Make packing" lors de la validation des listes de colisage entrantes).
- Il est possible de modifier manuellement les prix d'achats des produits dans le menu "Produits/Products cost price" ou de les importer dans un fichier csv avec comme colonne : le nom ou code du produit, le partenaire (représentant la société) et le prix.

Marche à suivre :
1. !!!FAIRE UN BACKUP DE LA BASE!!!
2. Définir quels emplacements sont à utiliser pour le calcul des prix d'achats.  Pour ce faire, il faut remplir le champ "Company (cost price)" UNIQUEMENT  sur les emplacements qui sont à utiliser pour calculer le nombre de produits en stock. P.ex. ne pas remplir le champ Company sur des emplacements de sortie. Menu : "Gestion des stocks/Configuration/Emplacements"
3. Ne pas oublier de sélectionner "Prix moyen" comme méthode de coût sur les produits concernés. Cela permet de recalculer le prix d'achat lors de chaque réception de produits.
""",
    "depends": ["product","stock","purchase"],
    "init_xml": [],
    "update_xml": ["hasa_multi_company_cost_price_view.xml","security/ir.model.access.csv"],
    "active": False,
    "installable": True,
}