# -*- coding: utf-8 -*-
################################################################################
#
# Copyright (c) 2006 Heonium SARL. (http://heonium.com) All Rights Reserved.
#                    Christophe CRIER <contact@heonium.com>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
################################################################################

import pooler,netsvc
import wizard
from osv.osv import osv_pool

import base64
import commands
import sys,os,random
import tools

email_send_form = '''<?xml version="1.0"?>
<form string="Send Invoice By E-Mail">
	<separator string="Sender" colspan="4"/>
	<field name="from"/>
	<field name="email"/>
	<separator string="Mail information" colspan="4"/>
	<field name="subject"/>
	<newline/>
	<field name="text" colspan="4"/>
</form>'''

email_send_fields = {
	'from': {'string':'From (name)', 'type':'char', 'size':64, 'required':True},
	'email': {'string':'From (email)', 'type':'char', 'size':64, 'required':True},
	'subject': {'string':'Subject', 'type':'char', 'size':256, 'required':True},
	'text': {'string':'Text', 'type':'text', 'required':True},
}

def _init_fields(self, cr, uid, data, context):
	#search information about user
	service = netsvc.LocalService("object_proxy")
	user = service.execute(cr.dbname, uid, 'res.users', 'read', [uid], ['address_id', 'signature'])[0]
	contact = service.execute(cr.dbname, uid, 'res.partner.address', 'read', [user['address_id'][0]])[0]
	if contact['email']:
		data['form']['email'] = contact['email']
	else:
		raise wizard.except_wizard('E-Mail Invoice - Error','Unable to send mail without sender mail address !!!')
	data['form']['from']=contact['name']
	return data['form']
	
def _mass_mail_send(self, cr, uid, data, context):
	nbr = 0
	logger = netsvc.Logger()
	self.pool = pooler.get_pool(cr.dbname)
	cr = pooler.get_db(cr.dbname).cursor()
	# Prepare sender information
	email_from = '%s <%s>' % (data['form']['from'], data['form']['email'])
	# Prepare and send mail
	invoices = self.pool.get('account.invoice').browse(cr,uid,data['ids'])
	print data['ids']
	for invoice in invoices:
		if invoice.address_invoice_id.email:
			# Prepare recipient's information
			email_to = '%s <%s>' % (invoice.address_invoice_id.name, invoice.address_invoice_id.email)
			# Create pdf invoice
			service = netsvc.LocalService('report.account.invoice.tspone')
			(result, format) = service.create(cr, uid, [invoice.id], data, context)
			# Send E-Mail and attachement
			tools.email_send_attach(
				email_from,
				[email_to],
				data['form']['subject'],
				data['form']['text'],
				attach=[('invoice.pdf',result)])
			nbr += 1
		else :
			tools.email_send(email_from,[email_from],'Send invoices - Error', "Error: Unable to send email to %s without mail address !!!" % (data['form']['from']))
			logger.notifyChannel("email_send",netsvc.LOG_INFO, "Error: Unable to send email to %s without mail address !!!" % (data['form']['from']))
	logger.notifyChannel("email_send",netsvc.LOG_INFO, "Info: Send email %s E-Mail !!!" % (nbr))
	tools.email_send(
		email_from,
		[email_from],
		'Send invoices - Info',
		'''Hi,
		
		We have send %s invoices.
		
		Regards.''' % (nbr))
	return {'email_sent': nbr}

class part_email(wizard.interface):
	states = {
		'init': {
			'actions': [_init_fields],
			'result': {'type': 'form', 'arch': email_send_form, 'fields': email_send_fields, 'state':[('send','Send Invoice'), ('end','Cancel')]}
		},
		'send': {
			'actions': [_mass_mail_send],
			'result': {'type': 'state', 'state':'end'}
		}
	}
part_email('account.invoice.email.send')