# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
#
{
	"name" : "Portugal : implementação do saft",
    'description': """Implementação da versão portuguesa do Ficheiro para auditoria fiscal
                    SAFT - Standard Audit File for Tax purposes
Módulo l10n-pt-base.

Implementa a exportação de um ficheiro de dados para efeitos de auditoria fiscal, de acordo com a 
Portaria 321-A/2007 de 26 de Março do Ministério das Finanças.

Autores:
    Paulino Ascenção <paulino1@sapo.pt>
    Filipa Andrade / Multibase - metodos '_write_products', '_write_invoice' e '_write_source_documents'
                                 na classe wizard_saft

Estão implementados todos os campos obrigatórios.

O assistente de exportação do ficheiro encontra-se no Menu: Gestão Financeira/Mapas Oficiais

Modificações a tabelas:

    res.partner
        Adicionados campos 'reg_com' e 'conservatoria' para registar os dados do registo comercial 
        dos parceiros
        
    res.company
        Adicionado campo 'open_journal' para especificar o diário de abertura. Os movimentos deste 
        diário são filtrados. 
        Acessível no menu: Administração/Utilizadores/Estrutura da empresa/Empresas -> configuração.
        
    account_tax
        Novos campos 'area_fiscal' e 'nivel_taxa', para cumprir com a especificação da tabela fiscal.
        
Falta implementar campos relativos à ordem de compra do cliente que originou a factura e informação 
sobre local e data de carga e descarga das mercadorias""",

	"version" : "0.1",
	"author" : "Paulino Ascenção<paulino1@sapo.pt> ; Filipa Andrade/Multibase",
	"website": "www.multibase.pt",
	"category" : "Localisation/Account charts",
	"depends" : ["account"],
	"init_xml" : [],
	"demo_xml" : [],
	"update_xml" : [ "saft_view.xml"    ], 
	"installable": True,
	"active": False,
}
