##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
import time
from osv import osv
from osv import fields

class office_textblock(osv.osv):
    '''
    Open ERP Model
    '''
    _name = 'office.textblock'
    _description = 'Office Management textblocks'
    
    _columns = {
        'name':fields.char('Title', size=64, required=False, readonly=False),
        'language_id':fields.many2one('res.lang', 'Language', required=True),
        'note': fields.text('Content'),
    }
office_textblock()

class office_letter(osv.osv):
    '''
    Open ERP Model
    '''
    _name = 'office.letter'
    _description = 'Office Letter'
    
    _columns = {
        'name':fields.char('Subject', size=256, required=True, readonly=False),
        'text_ids': fields.many2many('office.textblock', 'letter_textblock_rel', 'letter_id', 'textblock_id', 'Text Blocks'),
        #TODO : import time required to get currect date
        'letter_date': fields.date('Date', required=True),
        'partner_id':fields.many2one('res.partner', 'Partner', required=True),
        'partner_address_id':fields.many2one('res.partner.address', 'Address', required=True),
    }
office_letter()
