# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
import netsvc
logger = netsvc.Logger()
class office_letter(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(office_letter, self).__init__(cr, uid, name, context=context)
        self.localcontext.update( {
            'time' : time,
            'get_adr': self._get_adr
        })
        self.context = context
    def _get_adr(self, partner_id, type):
        res = []
        res_partner = pooler.get_pool(self.cr.dbname).get('res.partner')
        res_partner_address = pooler.get_pool(self.cr.dbname).get('res.partner.address')
        logger.notifyChannel('module', netsvc.LOG_INFO, 'partner_id: %s' % partner_id )
        addresses = res_partner.address_get(self.cr, self.uid, [partner_id], [type])
        adr_id = addresses and addresses[type] or False
        result = {
                  'name': False,
                  'street': False,
                  'city' : False,
                  'zip' : False,
                  'country_id' : False,
                 }
        if adr_id:
            result = res_partner_address.read(self.cr, self.uid, [adr_id],context=self.context.copy())
            result[0]['country_id'] = result[0]['country_id'] and result[0]['country_id'][1] or False
            return result   
         
        res.append(result)
        return res
    
report_sxw.report_sxw('report.office.letter.details', 'office.letter', 'addons/office_management/report/office_letter.rml', parser=office_letter)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
