# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Smile.fr . All Rights Reserved
#    @author Raphaël Valyi, Amadou Diallo
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class product_product(osv.osv):
    _inherit = "product.product"
    
    def list_price_change(self, cr, uid, ids, list_price=False, sale_tax_ids=False):
        res = {}
        if sale_tax_ids:
            sale_tax_ids = sale_tax_ids[0][2] #unwrapp the tax ids
            price = list_price
            product_taxes = self.pool.get('account.tax').browse(cr, uid, sale_tax_ids, {})
            for tax in self.pool.get('account.tax').compute(cr, uid, product_taxes, list_price, 1):
                price += tax['amount']
            res = {'value':{'list_price_tax_incl':price}}
        return res
    
    def list_price_tax_incl_change(self, cr, uid, ids, list_price_tax_incl=False, sale_tax_ids=False):
        res = {}
        if sale_tax_ids:
            sale_tax_ids = sale_tax_ids[0][2] #unwrapp the tax ids
            price = list_price_tax_incl
            product_taxes = self.pool.get('account.tax').browse(cr, uid, sale_tax_ids, {})
            for tax in self.pool.get('account.tax').compute_inv(cr, uid, product_taxes, list_price_tax_incl, 1):
                price -= tax['amount']
            res = {'value':{'list_price':price}}
        return res
    
    
    _columns = {
        'list_price_tax_incl': fields.float('Price Taxes Included'),
    }
product_product()