# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2004-2009 Bubbles-IT (<http://bubbles-it.be>).
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import osv, fields

class project_work_entry_wiz(osv.osv_memory):
    _name = "project_work_entry.wiz"

    _columns = {
        'project_id': fields.many2one('project.project', 'Show tasks from',required=True),
    }

    _defaults = {
        'project_id': lambda s,cr,u,c: c.get('project_id',False),
    }

    def action_open_view(self, cr, uid, ids, context={}):
        o = self.browse(cr, uid, ids, context)[0]

        # We need to find the correct view_id to use our custom view called project_work_entry_project_task_work_view
        # Otherwise the task_id field will not be on the view.
        model_data_ids = self.pool.get('ir.model.data').search(cr,uid,[('model','=','ir.ui.view'),('name','=','project_work_entry_project_task_work_view')])
        view_id = self.pool.get('ir.model.data').read(cr,uid,model_data_ids,fields=['res_id'])[0]['res_id']
        return {
            'view_type': 'form',
            'view_mode': 'form',
            'view_id': [view_id], # Need to force this view_id
            'res_model': 'project.task.work',
            'type': 'ir.actions.act_window',
            'context': {'project_id': o.project_id.id},
        }
project_work_entry_wiz()

class project_task_work_domain_on_task_id(osv.osv):
    _name = "project.task.work"
    _inherit = "project.task.work"

    def fields_view_get(self, cr, uid, view_id=None, view_type='form', context={}, toolbar=False):
        """
            This function changes the domain on the project_task field
            depending on the context value 'project_id'
        """
        result = super(project_task_work_domain_on_task_id, self).fields_view_get(cr, uid, view_id, view_type, context, toolbar)

        if 'project_id' in context and 'task_id' in result['fields']: # Make sure the 'task_id' is in the fields
            # By "default" the task_id is in domain user_id = uid and state = 'open'
            # In this view however we want to show only the open tasks from project in context['project_id']
            result['fields']['task_id']['domain'] = [('project_id','=', context['project_id']),('state','=','open')]
        return result
project_task_work_domain_on_task_id()

# vim:tabstop=4:softtabstop=4:shiftwidth=4:expandtab:autoindent:smartindent
