# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Smile.fr . All Rights Reserved
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class product_product(osv.osv):
    _inherit = "product.product"
    
    def _get_products_from_invoice_lines(self, cr, uid, ids, context={}):
        result = []
        for invoice_line in self.pool.get('account.invoice.line').browse(cr, uid, ids, context=context):
            result.append(invoice_line.product_id.id)
        return result
    
    def _get_products_from_invoices(self, cr, uid, ids, context={}):
        result = []
        for invoice in self.pool.get('account.invoice').browse(cr, uid, ids, context=context):
            for invoice_line in invoice.invoice_line:
                result.append(invoice_line.product_id.id)
        return result

    def _purchase_avg_price(self, cr, uid, ids, field_names, arg, context):
        res = {}
        for product in self.browse(cr, uid, ids,context=context):
            cr.execute("""select sum(quantity), sum(price_subtotal_incl) from account_invoice_line left join account_invoice on invoice_id = account_invoice.id
                        where (exclude_from_avg_price is Null or exclude_from_avg_price is False) and type in ('in_invoice','out_refund') and state in ('open','paid') and product_id=%s"""%(product.id))
            results = cr.fetchone()
            if results and len(results) > 0 and results[0]:
                res[product.id] = float(results[1] / results[0])
            else:
                res[product.id] = False

        return res
    
    
    _columns = {
        'purchase_avg_price': fields.function(_purchase_avg_price, method=True, type='float', string='Purchase Average Price',
                                                      store={
                                                                'account.invoice.line': (_get_products_from_invoice_lines, None, 10),
                                                                'account.invoice': (_get_products_from_invoices, None, 10),
                                                            }),
    }
product_product()