# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
from osv import osv, fields

class res_company(osv.osv):
    _name = 'res.company'
    _inherit = 'res.company'
    _columns = {
        'contract_conditions_ids': fields.one2many('contract.conditions', 'company_id', 'Contract conditions'),
        'contract_services_ids': fields.one2many('contract.services','company_id','Company Services'),
    }
    
res_company()

class contract_conditions(osv.osv):
    _name = 'contract.conditions'
    _columns = {
        'company_id': fields.many2one('res.company','Company'),
        'name': fields.char('Condition name', size=50),
        'paragraph_ids': fields.one2many('contract.conditions.paragraph', 'conditions_id', 'Contract conditions paragraphs')
    }
    
contract_conditions()

class contract_conditions_paragraph(osv.osv):
    _name = 'contract.conditions.paragraph'
    _columns = {
        'conditions_id': fields.many2one('contract.conditions', 'Contract condition'),
        'name': fields.char('Paragraph title', size=200),
        'text': fields.text('Paragraph text'),
    } 
contract_conditions_paragraph()

class contract_services(osv.osv):
    _name = 'contract.services'
    _columns = {
        'company_id': fields.many2one('res.company','Company'),
        'name': fields.char('Service',size=300),
        'details': fields.text('Service Details'),
    }
contract_services()
