# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution	
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    $Id$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import wizard

form = '''<?xml version="1.0"?>
<form string="Contract">
    <field name="projects" colspan="4"/>
    <newline/>
    <field name="conditions" colspan="4"/>
    <newline/>
    <field name="individual"/>
    <newline/>
    <field name="pay_method"/>
</form>'''
fields = {
        'projects' : {'string' : 'Projects', 'type' : 'many2one', 'relation' : 'project.project', 'required':False },        
        'conditions': {'string' : 'Conditions', 'type': 'many2one', 'relation': 'contract.conditions', 'required': True},
        'individual': {'string' : 'Individual meeting', 'type' : 'boolean', 'help' : 'Check this option in the case of a meeting of individual people. If this option remains unchecked is a corporate meeting.', 'required': False},
        'pay_method': {'string': 'Pay Method', 'type': 'char', 'size': 30, 'required': False},
}


class wizard_contract(wizard.interface):

    states = {
        'init': {
            'actions': [],
            'result': {'type':'form', 'arch':form, 'fields':fields, 'state':[('end','Cancel'),('contract','Print')]}
        },
        'contract': {
            'actions': [],
            'result': {'type':'print', 'report':'report_contract', 'state':'end'}
        }

    }
wizard_contract('sale.contract_wiz')
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
