# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (C) 2009 EduSense BV, Pieter J. Kersten, http://www.edusense.nl.
#    All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

{
    "name" : "Report TrueType Fonts",
    "version" : "1.0",
    "author": "EduSense BV",
    "depends" : [
        "base",
    ],
    "description" : """Module to add any TrueType font to reports.

    This module transparently extends the report machinery to use
    TrueType fonts.

    The normal mechanisms used in OpenERP use the standard Type1 fonts in
    a latin1 encoding. This prevents usage of wide char character sets,
    known as UTF-8 and UTF-16 fonts.

    This module enables the usage of any TrueType font, which are by
    definition UTF-8 encoded.

    The implementation chosen is a one-time registration
    of all found TrueType fonts in locations as advertised by
    rl_config.TTFontSearchPath during startup of the server. The path
    can be adapted to your needs. See reportlab's documentation for
    the details.

    The consequence of this implementation is that new fonts will only
    be loaded after restarting the OpenERP server. Advantage is that
    the penalty for scanning and registering is paid only once every
    server run.

    After loading, all reports generated by OpenERP can use these fonts
    by stating their formal mapped Type1 name, which can be found by
    running 'ttmkfdir' in the directory containing the fonts (unix like
    platforms).  The typefaces will be listed in the file 'fonts.scale'.

    TODO: One should be able to replace existing fonts using a map.
    TODO: One should know the registered fonts withoud peeking into the
          file system, let alone using rare utils.
    """,
    "website" : "http://www.edusense.nl",
    "category" : "Generic Modules/Reporting",
    "init_xml" : [],
    "demo_xml" : [],
    "update_xml" : [],
    "active": False,
    "installable": True,
}

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
