#!/usr/bin/env python
#coding: utf-8
#
# (c) 2007 Sednacom <http://www.sednacom.fr>
#
# authors :
#  - Brice < brice@sednacom.fr >

from osv import fields, osv
import netsvc

class purchase_order(osv.osv):
    _name = 'purchase.order'
    _inherit = 'purchase.order'

    def action_picking_create(self,cr, uid, ids, *args):
        picking_id = False
        for order in self.browse(cr, uid, ids):
            loc_id = order.partner_id.property_stock_supplier.id
            istate = 'none'
            if order.invoice_method=='picking':
                istate = '2binvoiced'
            picking_id = self.pool.get('stock.picking').create(cr, uid, {
                'origin': order.name+((order.origin and (':'+order.origin)) or ''),
                'type': 'in',
                'address_id': order.dest_address_id.id or order.partner_address_id.id,
                'invoice_state': istate,
                'purchase_id': order.id,
            })
            for order_line in order.order_line:
                if not order_line.product_id:
                    continue
                if order_line.product_id.product_tmpl_id.type in ('product', 'consu'):
                    dest = order.location_id.id

                    how_many = 1

                    if order_line.product_id.auto_tracking:
                        o_uom = self.pool.get('product.uom')

                        qty_orig = order_line.product_qty
                        uom_orig = order_line.product_uom.id
                        how_many = int(qty_orig)

                        uom = order_line.product_id.product_tmpl_id.uom_id.id
                        qty = o_uom._compute_qty(cr, uid, uom_orig, 1, uom)

                    else:
                        qty = order_line.product_qty
                        uom = order_line.product_uom.id

                    vals = {
                        'name': 'PO:'+order_line.name,
                        'product_id': order_line.product_id.id,
                        'product_qty': qty,
                        'product_uos_qty': qty,
                        'product_uom': uom,
                        'product_uos': uom,
                        'date_planned': order_line.date_planned,
                        'location_id': loc_id,
                        'location_dest_id': dest,
                        'picking_id': picking_id,
                        'move_dest_id': order_line.move_dest_id.id,
                        'state': 'assigned',
                        'purchase_line_id': order_line.id,
                        }
                    for folfer in range(how_many):
                        self.pool.get('stock.move').create(cr, uid, vals)
                    if order_line.move_dest_id:
                        self.pool.get('stock.move').write(cr, uid, [order_line.move_dest_id.id], {'location_id':order.location_id.id})

            wf_service = netsvc.LocalService("workflow")
            wf_service.trg_validate(uid, 'stock.picking', picking_id, 'button_confirm', cr)
        return picking_id

purchase_order()
