#!/usr/bin/env python
#coding: utf-8
#
# (c) 2007-2008 Sednacom <http://www.sednacom.fr>
#
# authors :
#  - Brice < brice@sednacom.fr >

from osv import fields, osv

class stock_tracking(osv.osv):
    _name = "stock.tracking"
    _inherit = "stock.tracking"

    def make_sscc(self, cr, uid, context={}):
        sequence = self.pool.get('ir.sequence').get(cr, uid, 'stock.lot.tracking')
        comp = ''
        if sequence.isdigit():
            comp = str(self.checksum(sequence))
        return sequence + comp

    _defaults = {
        'name' : make_sscc ,
    }

stock_tracking()

class stock_move(osv.osv):
    _name = 'stock.move'
    _inherit = 'stock.move'

    def action_done(self, cr, uid, sm_ids, context={}):
        brw_sms = self.browse(cr, uid, sm_ids, context)

        o_trk = self.pool.get('stock.tracking')

        for brw_sm in brw_sms:
            if brw_sm.product_id.auto_tracking \
                    and brw_sm.picking_id:
                if brw_sm.tracking_id:
                    continue
                else:
                    if brw_sm.picking_id.type == 'in':
                        pick = brw_sm.picking_id
                        seq = self.pool.get('ir.sequence').get(cr, uid, 'stock.lot.tracking')
                        vals = {
                            'name' : '%s(%s)' % (brw_sm.product_id.product_tmpl_id.name , seq) ,
                            'serial' : '%s[%s]' % (pick.purchase_id.name, pick.name),
                        }
                        new_tracking = o_trk.create(cr, uid, vals)
                        self.write(cr, uid, [brw_sm.id,], {'tracking_id' : new_tracking })
                    else:
                        pass
            else:
                continue

        return super(stock_move,self).action_done(cr, uid, sm_ids, context)

stock_move()

class stock_location(osv.osv):
    _name = 'stock.location'
    _inherit = 'stock.location'

    def _product_reserve(self, cr, uid, ids, product_id, product_qty, context={}):
        print '_product_reserve',ids, product_id, product_qty, context
        result = []
        amount = 0.0
        for id in self.search(cr, uid, [('location_id', 'child_of', ids)]):
            cr.execute("select product_uom,sum(product_qty) as product_qty from stock_move where location_dest_id=%d and product_id=%d and state='done' group by product_uom", (id,product_id))
            results = cr.dictfetchall()
            cr.execute("select product_uom,-sum(product_qty) as product_qty from stock_move where location_id=%d and product_id=%d and state in ('done', 'assigned') group by product_uom", (id,product_id))
            results += cr.dictfetchall()

            print 'results',results

            total = 0.0
            results2 = 0.0
            for r in results:
                amount = self.pool.get('product.uom')._compute_qty(cr, uid, r['product_uom'],r['product_qty'], context.get('uom',False))
                results2 += amount
                total += amount

            if total<=0.0:
                continue

            amount = results2
            if amount>0:
                if amount>min(total,product_qty):
                    amount = min(product_qty,total)
                result.append((amount,id))
                product_qty -= amount
                total -= amount
                if product_qty<=0.0:
                    print 'result',result
                    return result
                if total<=0.0:
                    continue
        return False

stock_location()
