#!/usr/bin/env python
#coding: utf-8
#
# (c) 2007-2008 Sednacom <http://www.sednacom.fr>
#
# based on module Report stock
#
# authors :
#  - Brice < brice@sednacom.fr >

from osv import osv, fields

class report_stock_by_tracking(osv.osv):
    _name = "report.stock.tracking"
    _description = "Stock report by tracking number"
    _auto = False
    _columns = {
            'name': fields.float('Quantity', readonly=True),
            'location_id': fields.many2one('stock.location', 'Location', readonly=True, select=True),
            'product_id': fields.many2one('product.product', 'Product', readonly=True, select=True),
            'tracking_id': fields.many2one('stock.tracking', 'Tracking lot', readonly=True, select=True),
            'uom_id' : fields.many2one('product.uom','Unit', readonly=True, select=True),
    }

    def init(self, cr):
        cr.execute("""
            create or replace view report_stock_tracking as (
                select max(id) as id,
                    location_id,
                    product_id,
                    tracking_id,
                    sum(qty) as name ,
                    uom_id
                from (
                    select -max(sm.id) as id,
                        sm.location_id,
                        sm.product_id,
                        sm.tracking_id,
                        -sum(sm.product_qty) as qty,
                        sm.product_uom as uom_id
                    from stock_move as sm
                    left join stock_location sl
                        on (sl.id = sm.location_id)
                    where state = 'done'
                        and sl.usage = 'internal'
                        and sm.tracking_id is not null
                    group by sm.location_id, sm.product_id, sm.product_uom, sm.tracking_id, sm.product_uom
                    union all
                    select max(sm.id) as id,
                        sm.location_dest_id as location_id,
                        sm.product_id,
                        sm.tracking_id,
                        sum(sm.product_qty) as qty,
                        sm.product_uom as uom_id
                    from stock_move as sm
                    left join stock_location sl
                        on (sl.id = sm.location_dest_id)
                    where sm.state = 'done'
                        and sl.usage = 'internal'
                        and sm.tracking_id is not null
                    group by sm.location_dest_id, sm.product_id, sm.product_uom, sm.tracking_id, sm.product_uom
                ) as report
                group by location_id, product_id, tracking_id, uom_id
            )""")

report_stock_by_tracking()
