#!/usr/bin/env python
#coding: utf-8
#
# (c) 2007 Sednacom <http://www.sednacom.fr>
#
# authors :
#  - Brice < brice@sednacom.fr >

import wizard
import pooler

class PropBag(object):
    def __init__(self, **kwargs):
        self.__dict__.update(kwargs)

init_form1_desc = """<?xml version="1.0"?>
<form string="Add product">
    <field name="product" />
    <field name="location" />
    <field name="load_stocks" />
</form>
"""

init_form2_desc = """<?xml version="1.0"?>
<form string="Add product" >
    <field name="qty" />
    <newline />
    <field name="stocks" colspan="4"
    width="640" height="480" nolabel="1"
    domain="[('name','>',0),]" />
</form>
"""

init_form1_fields = {
    'product' : {
        'string' : 'Product' ,
        'type' : 'many2one' ,
        'relation' : 'product.product' ,
        'required' : True ,
        'domain' : [('auto_tracking','=',True),],
    },
    'location' : {
        'string' : 'Location' ,
        'type' : 'many2one' ,
        'relation' : 'stock.location' ,
        'required' : True ,
    } ,
    'load_stocks' : {
        'string' : 'Load stocks' ,
        'type' : 'boolean' ,
    } ,
}

init_form2_fields = {
    'stocks' : {
        'string' : 'Stocks available' ,
        'type' : 'many2many' ,
        'relation' : 'report.stock.tracking' ,
        'required' : True ,
    } ,
    'qty' : {
        'string' : 'Quantity' ,
        'type' : 'float' ,
        'required' : True ,
    }
}

def _init_form1(obj, cr, uid, data, context={}):
    pooloo = pooler.get_pool(cr.dbname)

    o_so = pooloo.get('sale.order')
    b_so = o_so.browse(cr, uid, data['id'], context)

    res = {
        'location' : b_so.shop_id.warehouse_id.lot_stock_id.id ,
        'load_stocks' : False ,
    }
    return res

def _init_form2(obj, cr, uid, data, context={}):

    res = {
        'qty' : 1.0 ,
    }

    location = data['form']['location']
    product = data['form']['product']

    obj._props = PropBag(product=product,location=location)

    if data['form']['load_stocks']:
        pooloo = pooler.get_pool(cr.dbname)

        o_sbt = pooloo.get('report.stock.tracking')

        crit = [('location_id','=',location),('product_id','=',product),]

        sbt_ids = o_sbt.search(cr, uid, crit, 0, False)

        res['stocks'] = sbt_ids
    return res

def _add_line(self, cr, uid, data, context={}):
    if not data['form']['stocks']:
        return True

    pooloo = pooler.get_pool(cr.dbname)

    o_sbt = pooloo.get('report.stock.tracking')

    qty = data['form']['qty']
    product = self._props.product

    lot_id = o_sbt.browse(cr, uid, data['form']['stocks'][0][2][0]).tracking_id.id

    o_sol = pooloo.get('sale.order.line')

    vals = {
        'product' : product ,
        'qty' : qty ,
        'tracking' : lot_id ,
        'sale_order' : data['id'],
    }

    ret = o_sol.add_with_tracking(cr, uid, vals, context)

    #o_so = pooloo.get('sale.order.line')
    #o_so.write(cr, uid, [data['id'], ], {'note' : 'ligne-wizard'})

    return {}

class wizard_add_line_tracking( wizard.interface ):
    states = {
        'init' : {
            'actions' : [ _init_form1 , ],
            'result' : {
                'type' : 'form' ,
                'arch' : init_form1_desc ,
                'fields' : init_form1_fields ,
                'state' : [( 'end', 'Cancel' ), ( 'select_lot', 'Select lot' ), ],
                }
            },
        'select_lot' : {
            'actions' : [ _init_form2 , ],
            'result' : {
                'type' : 'form' ,
                'arch' : init_form2_desc ,
                'fields' : init_form2_fields ,
                'state' : [('end','Cancel'),('add','Add line'), ],
                }
            },
        'add' : {
            'actions' : [ _add_line],
            'result' : {
                'type' : 'state' ,
                'state' : 'end' ,
                }
            },
    }

wizard_add_line_tracking( 'rollmanagement.line.tracking' )
