# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2009 Smile.fr. All Rights Reserved
#    authors: Raphaël Valyi, Xavier Fernandez
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################
{
    "name" : "Very Simplified Point Of Sale",
    "description":"""Very Simplified Point Of Sale; if you are not sure about using the official pos module...
What we don't really like in the official addons pos module is that pos orders are not standard sale.order objects
and because of this a lot of code is very specific and thus not very reliable. Also modules like the product configurator
extending the sale.order object and views won't work easily with the official addons pos module. On the contrary
that module works well with the product configurator and other third party modules.
However, this module is only for simple cases: no touchscreen and no cash management ambition.

Especially, that module makes it easy to:
- encode sale orders for an anonymous customer (same default customer)
- generate new partners on the fly
- still allows to encode specific shipping and invoice addresses
- encode easily deposit payments at the order stage

This modules is better used in combination with the sale_invoices_link and sale_packings_link

Having an editable grid to enter order lines quickly is an easy change.
However, we didn't do it by default, because this be done more cleanly if the following blueprint were
implemented: https://blueprints.launchpad.net/openobject-server/+spec/merge-attributes-view-extension-point
""",
    "version" : "0.5",
    "author" : "Smile.fr",
    "category" : "Sale",
    "depends" : ["sale", "account"],
    "init_xml" : [],
    "demo_xml" : [],
    "update_xml" : ["sale_simple_pos_data.xml",
                    "security/ir.model.access.csv",
                    "invoice_view.xml",
                    "sale_view.xml",
                    "sale_workflow.xml",
                    "user_view.xml",
                    "account_view.xml"],
    "active": False,
    "installable": True
}
# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
