# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2009 Smile.fr. All Rights Reserved
#    authors: Xavier Fernandez
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv

class res_partner(osv.osv):
    _inherit = 'res.partner'
    
    def get_default_customer_id(self, cr, uid):
        data_ids = self.pool.get('ir.model.data').search(cr, uid, [('name', '=', 'default_customer'), ('module', '=', 'sale_simple_pos')])
        if data_ids:
            return self.pool.get('ir.model.data').read(cr, uid, data_ids[0], ['res_id'])['res_id']
        else:
            return False
    
    def unlink(self, cr, uid, ids, context=None):
        ids_to_unlink = ids
        if isinstance(ids, (int,long)):
            ids_to_unlink = [ids]
        default_customer_id = self.get_default_customer_id(cr, uid)
        if default_customer_id in ids_to_unlink:
            ids_to_unlink.remove(default_customer_id)
        return super(res_partner, self).unlink(cr, uid, ids_to_unlink, context)    

    
res_partner()