# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Smile.fr . All Rights Reserved
#    @author Raphaël Valyi
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv

class sale_order_line(osv.osv):
    _inherit = "sale.order.line"
    _auto = False    
    
    def init(self, cr):
        cr.execute("""ALTER TABLE sale_order_line ALTER discount TYPE numeric(16,6)""")
    
    def _get_target_discount_price(self, cr, uid, ids, field_name, arg, context={}):
        res = {}
        for so_line in self.browse(cr, uid, ids):
            if so_line.price_unit:
                res[so_line.id] = so_line.price_unit - (so_line.price_unit * so_line.discount or 0) / 100)
            else:
                res[so_line.id] = False
        return res
    
    def _set_target_discount_price(self, cr, uid, ids, name, value, arg, context):
        """Only here so to avoid storing the data in DB (would be redondant), 
        everything is fired in the target_discount_price_change event"""
        return True


    def target_discount_price_change(self, cr, uid, ids, target_discount_price=False, price_unit=False):
        res = {}
        if target_discount_price and price_unit:
            res['value'] = {'discount':(price_unit - target_discount_price) / price_unit * 100}
        return res

    _columns = {
        'target_discount_price': fields.function(_get_target_discount_price, fnct_inv=_set_target_discount_price,
                 method=True, type='float', string='Target Discount Price'),
    }
    
sale_order_line()
    
