#coding: utf-8
#
# (c) 2007 Sednacom <http://www.sednacom.fr>
#
# authors :
#  - Brice < brice@sednacom.fr >

from osv import fields, osv

class ir_sequence(osv.osv):
    _name = 'ir.sequence'
    _inherit = 'ir.sequence'

    def _get_last(self, cr, uid, seq_ids, name, args, context={}):
        str_ids = ', '.join([str(seq_id) for seq_id in seq_ids])
        sql = "select id, number_next-1 as last from ir_sequence where id in (%s)" % str_ids
        cr.execute(sql)
        return dict(cr.fetchall())

    def _preview(self, cr, uid, seq_ids, name, args, context={}):
        str_ids = ', '.join([str(seq_id) for seq_id in seq_ids])
        sql = "select id, number_next, prefix, padding, suffix from ir_sequence where id in (%s)" % str_ids
        cr.execute(sql)
        res = {}
        for row in cr.dictfetchall():
            #  (4, 1, '%(year)s/', 3, None)
            # self._process(res['prefix']) + '%%0%sd' % res['padding'] % res['number_next'] + self._process(res['suffix'])
            seq = ('%%0%sd' % row['padding']) %  row['number_next']
            res[row['id']] = self._process(row['prefix']) + seq + self._process(row['suffix'])
        return res

    _columns = {
        'number_last' : fields.function(_get_last, method=True, type="int", string="Last"),
        'preview' : fields.function(_preview, method=True, type="string", string="Preview"),
    }

ir_sequence()
