# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution    
#    Copyright (C) 2004-2009 Smile.fr . All Rights Reserved
#    @author Raphaël Valyi, Amadou Diallo
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields,osv
import pooler
import time
import netsvc

class stock_picking(osv.osv):
    _inherit = "stock.picking"


    def action_invoice_create(self, cr, uid, ids, journal_id=False, group=False, type='out_invoice', context=None):
        invoice_ids = super(stock_picking, self).action_invoice_create(cr, uid, ids, journal_id, group, type, context)
        for picking in self.browse(cr, uid, ids):
            self.pool.get('account.invoice').write(cr, uid, invoice_ids[picking.id], {'origin_picking_id':picking.id})
        return invoice_ids

    
    #TODO copy from picking
    def _create_invoice(obj, cr, uid, data, context):
        if data['form'].get('new_picking',False):
            data['id'] = data['form']['new_picking']
            data['ids'] = [data['form']['new_picking']]
        pool = pooler.get_pool(cr.dbname)
        picking_obj = pooler.get_pool(cr.dbname).get('stock.picking')
        mod_obj = pool.get('ir.model.data')
        act_obj = pool.get('ir.actions.act_window')
    
        type = data['form']['type']
    
        res = picking_obj.action_invoice_create(cr, uid, data['ids'],
                journal_id=data['form']['journal_id'],group=data['form']['group'],
                type=type, context= context)
    
        invoice_ids = res.values()    
        if not invoice_ids:
            raise  wizard.except_wizard(_('Error'),_('Invoice is not created'))
    
        if type == 'out_invoice':
            xml_id = 'action_invoice_tree5'
        elif type == 'in_invoice':
            xml_id = 'action_invoice_tree8'
        elif type == 'out_refund':
            xml_id = 'action_invoice_tree10'
        else:
            xml_id = 'action_invoice_tree12'
    
        result = mod_obj._get_id(cr, uid, 'account', xml_id)
        id = mod_obj.read(cr, uid, result, ['res_id'])    
        result = act_obj.read(cr, uid, id['res_id'])
        result['res_id'] = invoice_ids    
        return result

    
    def action_move(self, cr, uid, ids, context={}):
        for picking in self.browse(cr, uid, ids):
            if picking.invoice_state == "2binvoiced":
                cr.commit() #ensure that picking has been eventually split
                so = picking.sale_id
                
                #eventually block the picking:
                so_lines_total_price = 0
                for move in picking.move_lines:
                    so_line = self.pool.get('sale.order.line').browse(cr, uid, move.sale_line_id.id)
                    sale_shop = so_line.order_id.shop_id
                    print "so_line.price_subtotal * move.product_qty / so_line.product_uos_qty", so_line.price_subtotal_incl, move.product_qty, so_line.product_uos_qty
                    if so_line.price_subtotal_incl:
                        so_lines_total_price += so_line.price_subtotal_incl * move.product_qty / so_line.product_uos_qty
                    else:
                        so_lines_total_price += so_line.price_subtotal * move.product_qty / so_line.product_uos_qty
                
                print "so_lines_total_price", so_lines_total_price
                if (- so.partner_id.credit) * 1.001 < so_lines_total_price * float(sale_shop.picking_blocking_deposit_percent) / 100.0:
                    raise osv.except_osv(_('Error !'), _("Not enough deposits amount! Sale Shop is configured to block picking if paid amount is below %s percent, that is %s") % (sale_shop.picking_blocking_deposit_percent, so_lines_total_price * float(sale_shop.picking_blocking_deposit_percent) / 100.0))

                
                #then invoice picking:
                data2 ={'form':{'group': 0, 'type':'out_invoice', 'journal_id': sale_shop.picking_invoicing_journal_id.id}, 'ids':[picking.id], 'id': picking.id}
                self._create_invoice(cr, uid, data2, {}) #TODO real context


            super(stock_picking, self).action_move(cr, uid, ids, context) #actually perform the move

    
stock_picking()