#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from osv import osv,fields
import wizard
import stock_period
import pooler
import sets
import time
from mx import DateTime as mdt


form='''<?xml version="1.0"?>
<form string="Close Stock Period">
	<label name="info" string="Choose the opened period that you want to close" colspan="4"/>
	<field name="open"/>
</form>'''




class wiz_close_period(wizard.interface):

	def _query_product(self,cr, uid, data, context):
		period = data['form']['open']
		print "period :",period
		pool = pooler.get_pool(cr.dbname)
		crit = [('state','=','open'),('id','=',period)]
		stock_period_obj = pool.get('stock.period')
		res = stock_period_obj.search(cr, uid, crit)
		if res:
			ids = stock_period_obj.read(cr,uid,res,['date_end',])
			date_end = ids[0]['date_end']
			end = mdt.DateTime(int(date_end[0:4]),int(date_end[5:7]),int(date_end[8:10]))
			now = mdt.now()
			if end >= now:
				raise osv.except_osv('Cannot close a period','Date end shouldn\'t be superior or egal than now.')
				modify=False
			else:
				modify = stock_period_obj.close_period(cr, uid, res[0])
			return modify
		else:
			raise osv.except_osv('Cannot close a period','No opened period found')


	fields={
		'open': {'string':"Opened Period", 'type':'many2one', 'relation':'stock.period', 'required':True, 'domain':"[('state','=','open')]",},
		}



	states={
		'init':{
			'actions':[],
			'result':{'type':'form', 'arch':form, 'fields':fields, 'state':[('end', 'No'), ('close', 'Yes')]}
		},
		'close':{
			'actions':[],
			'result':{'type':'action', 'action':_query_product, 'state':'end'}
		}
	}
wiz_close_period('wizard_close_period')

