#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from osv import osv,fields
import wizard
import netsvc
import stock_period
import pooler
import sets
import time
from mx import DateTime as mdt


form='''<?xml version="1.0"?>
<form string="Create Stock Period">
	<label name="info" string="Please complete this form to generate the stock Period" colspan="4"/>
	<field name="name"/>
	<separator string="Type of Period" colspan="4"/>
	<label name="label_date" string="Choose a type and the during" colspan="4"/>
	<field name="during"/>
	<field name="type"/>	
	<separator string="Period" colspan="4"/>
	<label name="label_date" string="Choose a period to create your stock period" colspan="4"/>
	<field name="date1"/>
</form>'''




class wiz_create_period(wizard.interface):
	def init(self,cr, uid, data, context):
		req = cr.execute('SELECT max(date_end) FROM stock_period')
		res= cr.fetchall()
		if res[0][0]:
			last_date_end = res[0][0]
			date_start = mdt.DateTime(int(last_date_end[0:4]),int(last_date_end[5:7]),int(last_date_end[8:10])) + mdt.oneDay
			date_start = str(date_start.year) + '-' + str(date_start.month) + '-' + str(date_start.day)
			return {'date1' : date_start}
		else:
			req = cr.execute('SELECT min(date) FROM stock_move')
			res= cr.fetchall()
			if res[0][0]:
				date_start = res[0][0]
				return {'date1' : date_start}
			else:
				date_start = time.strftime('%Y-%m-01')
				return {'date1' : date_start}

	def onchange_for_date_end(self, cr, uid, date1, type_id, during):
		date_start = date1
		if not date_start or not type_id or not during:
			return {}
		if type_id=='year':
			date_end = mdt.DateTime(int(date_start[0:4]),int(date_start[5:7]),int(date_start[8:10])) + during * mdt.RelativeDate(years=1)
		if type_id=='month':
			date_end = mdt.DateTime(int(date_start[0:4]),int(date_start[5:7]),int(date_start[8:10])) + during * mdt.RelativeDate(months=1)
		if type_id=='day':
			date_end = mdt.DateTime(int(date_start[0:4]),int(date_start[5:7]),int(date_start[8:10])) + during * mdt.RelativeDate(days=1)
		if type_id=='week':
			date_end = mdt.DateTime(int(date_start[0:4]),int(date_start[5:7]),int(date_start[8:10])) + during * mdt.RelativeDate(weeks=1)
		date_end_month = str(date_end.month)
		date_end_day = str(date_end.day)
		if len(str(date_end.month))==1:
			date_end_month = '0' + str(date_end.month)
		if len(str(date_end.day))==1:
			date_end_day = '0' + str(date_end.day)
		date = str(date_end.year) + '-' + date_end_month + '-' + date_end_day
		return date


	def _query_product(self,cr, uid, data, context):
		name = data['form']['name']
		during = data['form']['during']
		type = data['form']['type']
		date_start = data['form']['date1']
		date_end = self.onchange_for_date_end(cr,uid,date_start, type, during)
		pool = pooler.get_pool(cr.dbname)
		stock_period_obj = pool.get('stock.period')
		create = stock_period_obj._create_period(cr, uid, date_start, date_end, name, during,type)
		return create

	fields={
		'name': {
                	'string': 'Choose a name',
                	'type': 'char',
                	'required': True,
                	'size': 64,
        		},
		'date1': {
                	'string': 'Start of period',
                	'type': 'date',
                	'required': True,
			'readonly' : True,
        		},
        	'date2': {
                	'string': 'End of period',
                	'type': 'date',
			'readonly' : True,
                	},
		'type' : {
			'string': 'Period type',
			'type' : 'selection',
			'selection' : [
			('day','Day'),
			('week','Week'),
			('month','Month'),
			('year','Year'),
			],
			'default' : lambda *a: 'month',
			'required' : True,
			},
		'during': {
                	'string': 'during of period',
                	'type': 'char',
			'default' : lambda *a: '1',
                	'required': True,
                	'size': 64,
        		},
		}



	states={
		'init':{
			'actions':[init],
			'result':{'type':'form', 'arch':form, 'fields':fields, 'state':[('end', 'Cancel'), ('create', 'Create')]}
		},
		'create':{
			'actions':[],
			'result':{'type':'action', 'action':_query_product, 'state':'end'}
		}
	}
wiz_create_period('wizard_create_period')

