#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import time
from report import report_sxw
from osv import osv

#supplier_id = data['form']


class supplier_product(report_sxw.rml_parse):
	def  __init__(self, cr, uid, name, context):
		super(supplier_product, self).__init__(cr, uid, name, context)
		self.localcontext.update({
			'time': time,
			'lines': self.lines,		
		})
		self._context=context


	def preprocess(self, objects, data, ids):
		self._data = data		
		self.cr.execute("SELECT max(id) as id from supplier_product WHERE supplier_id=%s AND date_create < %s",(data['form']['supplier_id'], data['form']['date2'],))		
		new_ids = [rec['id'] for rec in self.cr.dictfetchall() ]	
		print new_ids		
		new_objects = self.pool.get('supplier.product').browse(self.cr, self.uid, new_ids, context=self._context )		
		super(supplier_product, self).preprocess(new_objects, data, new_ids)
		

	def lines(self, objects):
		supplier_id = self._data['form']['supplier_id']
		date_depart = self._data['form']['date1']
		date_fin = self._data['form']['date2']
		#on recupere l'id des order compris dans la plage de recherche
		self.cr.execute("SELECT DISTINCT po.id, po.name, po.date_order FROM purchase_order po LEFT JOIN supplier_product sp on (sp.supplier_id=po.partner_id) WHERE po.partner_id=%s AND po.state='approved' OR po.state='done' AND date_order BETWEEN %s AND %s",(supplier_id, date_depart, date_fin,))
		res_sql=self.cr.dictfetchall()
		ret = []
		for order in res_sql:
			# on recupere la date de création de la liste de prix la plus grande pour chaque order
			sql_date = """
				SELECT MAX(date_create) 
				FROM supplier_product 
				WHERE date_create BETWEEN %s and %s
				AND date_create <= %s
				AND supplier_id = %s
				"""
			date = self.cr.execute(sql_date,(date_depart,date_fin,order['date_order'], supplier_id,))
			res_date = self.cr.fetchall()
			date=res_date[0][0]
			#print 'order id',order['id'],'date ',date
			if date:
				#on recherche dans purchase_order_line les infos dont on a besoin
				sql_order_line = """
					SELECT name, price_unit, product_qty, product_id
					FROM purchase_order_line
					WHERE order_id = %s
					"""
				req_order_line = self.cr.execute(sql_order_line,(order['id'],))
				res_order_line = self.cr.dictfetchall()
				for order_line in res_order_line:
					#on recherche dans la liste le prix adéquate en fct des qté
					sql_qty = """
						SELECT MAX(min_quantity)
						FROM supplier_product_line spl, supplier_product sp
						WHERE spl.supplier_product_id = sp.id
						AND sp.date_create = %s
						AND spl.product_id = %s
						AND sp.supplier_id = %s
						AND min_quantity <= %s 
						"""
					req_qty = self.cr.execute(sql_qty, (date, order_line['product_id'], supplier_id, order_line['product_qty'],))
					res_qty = self.cr.fetchall()
					qty=res_qty[0][0]
	
					sql_spl = """
						SELECT DISTINCT spl.min_quantity, spl.price, spl.delay
						FROM supplier_product_line spl, supplier_product sp
						WHERE spl.supplier_product_id = sp.id
						AND sp.date_create = %s
						AND spl.product_id = %s
						AND sp.supplier_id = %s 
						AND spl.min_quantity = %s
						"""
					req_spl = self.cr.execute(sql_spl, (date, order_line['product_id'], supplier_id, qty,))
					res_spl = self.cr.dictfetchall()
					for spl in res_spl:
						ecart = order_line['price_unit'] * order_line['product_qty'] - spl['price'] * order_line['product_qty']
						ecart_unit = order_line['price_unit'] - spl['price']								
						ecart_pourcent = float						
						ecart_pourcent = (order_line['price_unit'] - spl['price'])/order_line['price_unit']*100 			
						ret.append(
							{'order' : order['name'],
							'date_order' : order['date_order'],
							'product' : order_line['name'],
							'price_order' : order_line['price_unit'],
							'qty' : order_line['product_qty'],
							'price_total' : order_line['price_unit'] * order_line['product_qty'],						
							'date_pricelist' : date,
							'price_pricelist' : spl['price'],
							'difference' : ecart_unit,							
							'difference_total' : ecart,
							'difference_pourcent' : ecart_pourcent,
							})
						#print "product",order_line['name'], "date order", order['date_order'], "price order", order_line['price_unit'], "qty : ",order_line['product_qty'], "date pricelist", date, "pricelist", spl['price'], "ecart : ", ecart
		return ret

report_sxw.report_sxw('report.supplier_product_compare', 'supplier.product', 'addons/supplier_product/report/compare.rml', parser=supplier_product, header=False)


#ELECT DISTINCT po.name, po.date_order, pt.name, pol.price_unit, spl.price,  spl.date_create
#			FROM purchase_order po,	supplier_product sp, purchase_order_line pol, supplier_product_line spl, product_template pt 
#			WHERE sp.supplier_id = po.partner_id
#			AND po.id = pol.order_id 
#			AND po.partner_id=2 
#			AND spl.supplier_product_id = sp.id 
 #                       AND po.state='approved' OR po.state='done'
  #                      AND pol.product_id = spl.product_id
   #                     AND po.date_order >= spl.date_create
    #                    AND spl.date_create < now()
     #                   AND spl.min_quantity <= pol.product_qty
      #                  and pol.product_id = pt.id
                        

