#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

import time
from osv import osv,fields


class supplier_product(osv.osv):
	_name="supplier.product"
	_description="Make a supplier product list"

	_columns={
		'supplier_id': fields.many2one('res.partner','Supplier', select=True, required=True),
		'date_create': fields.date('Date create', select=True, required=True),
		'supplier_product_line': fields.one2many('supplier.product.line', 'supplier_product_id', 'Price Lines', select=True),
		}
	_defaults={
		 'date_create': lambda *a: time.strftime('%Y-%m-%d'),
		}
	_rec_name = "supplier_id"

	_order = 'date_create desc'

	def name_get(self, cr, uid, ids, context={}):
		# res = [(id,name),(id,name',....]
		return [ (sp.id , sp.supplier_id.name) for sp in self.browse(cr, uid, ids, context) ]

supplier_product()


class supplier_product_line(osv.osv):
	_name="supplier.product.line"
	_description="Make a supplier product line"
	
	_columns={
		'supplier_product_id': fields.many2one('supplier.product','Supplier',  ondelete='cascade', select=True),
		'product_id' : fields.many2one('product.template','Product', required=True, select=True),
		'min_quantity':  fields.integer('min quantity'),
		'price':  fields.float('Unit Price', required=True),	
		'delay' : fields.integer('delay'),
		'date_create': fields.date('Date create', select=True),
		}

	_defaults={
		 'date_create': lambda *a: time.strftime('%Y-%m-%d'),
		}

	_rec_name = "product_id"
supplier_product_line()

