#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from osv import fields
import wizard
import supplier_product
import pooler
import sets
import time


form='''<?xml version="1.0"?>
<form string="Supplier Products list">
	<label name="info" string="Please complete this form to generate the product's list" colspan="4"/>
	<separator string="Suppliers" colspan="4"/>
	<label name="label_partners" string="Choose one or many Suppliers :" colspan="2"/>
	<field name="partner_id" colspan="4"/>
	<separator string="Products" colspan="4"/>
	<label name="label_products" string="Choose one or many Products :" colspan="2"/>
	<field name="product_id" colspan="4"/>
	<separator string="Period" colspan="4"/>
	<label name="label_date" string="Choose a date or period to find your product's lists" colspan="3"/>
	<field name="date1"/>
        <field name="date2"/>

</form>'''



def init_form(self, cr, uid, data, context):
	
	if data['model']== 'res.partner':
		#print 'data',data
		return {'partner_id' : data['ids']}
	elif data['model']== 'product.product':
		return {'product_id' : data['ids']}


class wiz_supplier(wizard.interface):
	

	def _query_product(self,cr, uid, data, context):
		ids_supplier = data['form']['partner_id'][0][2]
		ids_product = data['form']['product_id'][0][2]
		date1 = data['form']['date1']
		date2 = data['form']['date2']
		#print 'id_supplier',id_supplier
		#print 'id_product', ids_product
		ids_supp=list()
		
		for id_supplier in ids_supplier:
			for ids in ids_product:			
				cr.execute("SELECT spl.id FROM supplier_product_line spl LEFT JOIN supplier_product sp on (spl.supplier_product_id=sp.id ) WHERE sp.supplier_id=%s AND spl.product_id=%d AND sp.date_create BETWEEN %s AND %s",(id_supplier, ids, date1, date2))
       				res_sql=cr.fetchall()
				if res_sql:
					#print "---",ids,"---",res_sql
					ids_supp = ids_supp + list( sets.Set( [rec[0] for rec in res_sql] ) )
				#else:
				#	print "pas de données pour : ",ids
			product_ids = ', '.join( [str( prd_id ) for prd_id in ids_supp] )
		return {
                	'domain': "[('id','in',[%s])]" % product_ids, 
                	'name': 'Products list',
                	'view_type': 'form',
                	'view_mode': 'tree,form',
                	'res_model': 'supplier.product.line',
                	'view_id': False,
                	'type': 'ir.actions.act_window'
        	}
		#print product_ids
		#return list

	fields={
		'partner_id':{
			'string':'Partners',
			'type':'many2many',
			'relation':'res.partner',
			'required':True,
			},
	
		'product_id':{
			'string':'Products',
			'type':'many2many',
			'relation':'product.product',
			'required':True,
			},
		 'date1': {
                	'string': 'Start of period',
                	'type': 'date',
                	'required': True,
                	'default': lambda *a: time.strftime('%Y-01-01')
        		},
        	'date2': {
                	'string': 'End of period',
                	'type': 'date',
                	'required': True,
                	'default': lambda *a: time.strftime('%Y-%m-%d')
        		},

		}		


		
	states={
		'init':{
			'actions':[init_form,],
			'result':{'type':'form', 'arch':form, 'fields':fields, 'state':[('end', 'Cancel'), ('report', 'View')]}
		},
		'report':{
			'actions':[],
			'result':{'type':'action', 'action':_query_product, 'state':'end'}
		}
	}
wiz_supplier('wizard_product_supplier_listprice_partner')
wiz_supplier('wizard_product_supplier_listprice_product')




