#!/usr/bin/env python
#coding: utf-8

# (c) 2007 Sednacom <http://www.sednacom.fr>
# author : gael@sednacom.fr

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

from osv import fields
import wizard,netsvc
import supplier_product
import pooler

_supplier_form='''<?xml version="1.0"?>
			<form string="Make Supplier Products list">
				<label string="Choose you supplier to perform the product's list" colspan="3" />
				<label string="Leave blank for all suppliers" colspan="3" />
				<field name="supplier_id" />
			</form>'''

_supplier_fields = {
	'supplier_id': {'string':"Supplier Name", 'type':'many2one', 'relation':'res.partner', 'required':False, 'domain':"[]"},
	}

def _query_product(self,cr, uid, data, context):
	id_supplier = data['form']['supplier_id']
	if id_supplier:
		pool = pooler.get_pool(cr.dbname)
		o_psi = pool.get('product.supplierinfo')
		crit = [('name', '=', id_supplier),]
		psi_ids = o_psi.search(cr, uid, crit)
		psis = o_psi.browse(cr, uid, psi_ids , context)
		res={}
		o_sp = pool.get('supplier.product')
		for psi in psis:
			res = {'supplier_id':id_supplier,'supplier_product_line':[]}
			for price_id in psi.pricelist_ids:
				res2 = {'delay':psi.delay,'product_id':psi.product_id.id,'price':price_id.price,'min_quantity':price_id.min_quantity}
				res['supplier_product_line'].append((0,0,res2))
			if res['supplier_product_line']:
				sp_id = o_sp.create(cr, uid, res)
				#print 'res',res
	else:
		pool = pooler.get_pool(cr.dbname)
		o_psi = pool.get('product.supplierinfo')
		cr.execute("SELECT DISTINCT name FROM product_supplierinfo ORDER BY name ")
        	res_sql=cr.fetchall()
		for allpsi in res_sql:	 
			id_supplier = allpsi[0]
			crit = [('name', '=', id_supplier),]
			psi_ids = o_psi.search(cr, uid, crit)
			psis = o_psi.browse(cr, uid, psi_ids , context)
			res={}
			o_sp = pool.get('supplier.product')
			for psi in psis:
				res = {'supplier_id':id_supplier,'supplier_product_line':[]}
				for price_id in psi.pricelist_ids:
					res2 = {'delay':psi.delay,'product_id':psi.product_id.id,'price':price_id.price,'min_quantity':price_id.min_quantity}
					res['supplier_product_line'].append((0,0,res2))
				if res['supplier_product_line']:
					sp_id = o_sp.create(cr, uid, res)
					#print 'res', res
	return res

class wiz_supplier(wizard.interface):
	states = {
		'init': {
			'actions': [],
			'result': {'type': 'form', 'arch':_supplier_form, 'fields':_supplier_fields, 'state':[('end','Cancel'),('launch','Launch task') ]}
		},
		'launch': {
			'actions': [],
			'result': {'type':'action', 'action':_query_product, 'state':'end'}
		},
		}
wiz_supplier('wizard_product_supplier_make')



